package classes.login
{	
	/**

	INTELLIGERE SCS
	=========================================================================
	Copyright (c) 2007
	http://www.gnstudio.com

	This file is part of Intelligere SCS

    Intelligere SCS is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
   	(at your option) any later version.

    Intelligere SCS is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with Intelligere SCS; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
	=========================================================================

	@package  	Intelligere SCS
 	@version  	Beta 3.0
 	@idea maker Giorgio Natili
 	@author   	Giorgio Natili <g.natili@gnstudio.com>

	**/
	
	import mx.containers.Panel;
	import mx.controls.Label;
	import mx.controls.TextInput;
	import mx.controls.Button;
	import mx.controls.Alert;
	
	import flash.events.Event;
	import mx.events.FlexEvent;
	import flash.events.MouseEvent;
	
	import classes.utils.Constants;
	import classes.utils.CustomDispatcher;
	
	import mx.core.Application;
	import classes.users.Speaker;
	import mx.events.CloseEvent;
	
	import classes.utils.MD5;

	public class LoginPanel extends Panel	{
		
		[Bindable]
		public var textData:Array;
		
		private const LOGIN_BUTTON_TXT:String = "LOGIN";
		
		private var loginLabel:Label;
		private var loginInput:TextInput;
		
		private var passwordLabel:Label;
		private var passwordInput:TextInput;
		
		private var doLoginButton:Button;		
		
		/**
		* Constructor
		* Initialize the listener for the event initializeView
		*/ 		
		function LoginPanel(){		
			
			addEventListener("initializeView", init);
			addEventListener("loginResult", handleLoginResult);
			addEventListener(LoginDataProvidedEvent.LOGINDATA_PROVIDED_EVENT, doForcedLogin);
			
		}
		
		/**
		* Define the DisplayObjects used in the panel
		* @param e Event
		*/ 
		private function init(e:Event):void{
			
			loginLabel = new Label();
			loginLabel.x = 20;
			loginLabel.y = 20;
			loginLabel.width = width - 60;
			loginLabel.height = 20;
			
			addChild(loginLabel);
			
			loginInput = new TextInput();
			loginInput.x = 20;
			loginInput.y = 40;
			loginInput.width = width - 60;
			loginInput.height = 20;
			
			loginInput.addEventListener(FlexEvent.ENTER, doCheck);
			
			addChild(loginInput);
			
			passwordLabel = new Label();
			passwordLabel.x = 20;
			passwordLabel.y = loginInput.y + 40;
			passwordLabel.width = width - 60;
			passwordLabel.height = 20;
			
			addChild(passwordLabel);
			
			passwordInput = new TextInput();
			passwordInput.x = 20;
			passwordInput.y = passwordLabel.y + 20 ;
			passwordInput.width = width - 60;
			passwordInput.height = 20;
			passwordInput.displayAsPassword = true;
			
			passwordInput.addEventListener(FlexEvent.ENTER, doCheck);
			
			addChild(passwordInput);
			
			doLoginButton = new Button();
			doLoginButton.width = 65;
			doLoginButton.height = 22;
			doLoginButton.y = passwordInput.y + 40;
			doLoginButton.x = passwordInput.x + passwordInput.width - doLoginButton.width;
			doLoginButton.label = LOGIN_BUTTON_TXT;
			
			doLoginButton.addEventListener(MouseEvent.CLICK, doCheck);
			
			addChild(doLoginButton);
						
			setText(textData[0], textData[1], textData[2]);
			
		}
		
		private function handleLoginResult(e:LoginEvent):void{
			
			// TODO
			// Make a fine tuning in order to initialize
			// the new user class
			
			Application.application.user = new Speaker();
			
			var msgAlert:Alert;
					
			if(e.userRole == "speaker" && e.logged == true){
					
					if(e.message.length > 0){
						
						msgAlert = Alert.show(e.message, Constants.textValues.alertTitle, Alert.OK, this, null);
						msgAlert.setStyle("themeColor",Constants.colorValues.themecolor);
						return;
						
					}
					
					Application.application.username = "*Speaker";
					Application.application.role = "speaker";
					Application.application.user.username = "*Speaker";
					Application.application.user.role = "speaker";
					
					Application.application.logged = true;
					
					Application.application.dispatchEvent(new Event("initializeIntelligereStartupState"));
					
				}else if(e.userRole == "guest" && e.logged == true){
					
					if(e.message.length > 0){
						
						msgAlert = Alert.show(e.message, Constants.textValues.alertTitle, Alert.OK, this, handleAutomaticLoginFailure);
						msgAlert.setStyle("themeColor",Constants.colorValues.themecolor);
						return;
						
					}
					
					
					Application.application.user.username = e.userName;
					Application.application.user.role = e.userRole;	
					
					Application.application.username = e.userName;
					Application.application.role = e.userRole;
					
					Application.application.logged = true;
					
					Application.application.dispatchEvent(new Event("initializeIntelligereStartupState"));
							
			}else{
				
				var alertPass:Alert = Alert.show(Constants.textValues.invalidCredentials + e.userName, Constants.textValues.alertTitle, Alert.OK, this, handleAutomaticLoginFailure);
				alertPass.setStyle("themeColor",Constants.colorValues.themecolor);
								
			}
						
		}
		
		private function handleAutomaticLoginFailure(e:CloseEvent):void{
			
			this.parentDocument.dispatchEvent(new Event("resetUserInterface"));
			
		}	
		
		/**
		* Listener to the LoginDataProvidedEvent.LOGINDATA_PROVIDED_EVENT event
		* it forces the login procedure without any user input
		* @param e LoginDataProvidedEvent
		*/
		private function doForcedLogin(e:LoginDataProvidedEvent):void{
			
			doLogin(e.username, e.password);			
			
		}
		
		/**
		* Check the text inserted in the form fields
		* @param e Event
		*/ 
		private function doCheck(e:Event):void{
			
			switch(true){
				
				case loginInput.text.length < 3:
				var alertLog:Alert = Alert.show(Constants.textValues.loginAlert, Constants.textValues.alertTitle, Alert.OK, this, null);
				alertLog.setStyle("themeColor",Constants.colorValues.themecolor);
				break;
				
				case passwordInput.text.length < 3:
				var alertPass:Alert = Alert.show(Constants.textValues.passwordAlert, Constants.textValues.alertTitle, Alert.OK, this, null);
				alertPass.setStyle("themeColor",Constants.colorValues.themecolor);
				break;
				
				default:
				doLogin(loginInput.text, passwordInput.text);
				
			}
			
						
		}
		
		/**
		* Check if the username and password are valid
		* and which is the role of the user
		* @param lg String
		* @param psw Sreing
		*/ 
		private function doLogin(lg:String, psw:String):void{
			
			if(Constants.externalValues.checkLogin == ""){
			
				var alertPass:Alert = Alert.show(Constants.textValues.disabledAlert, Constants.textValues.alertTitle, Alert.OK, this, null);
				alertPass.setStyle("themeColor",Constants.colorValues.themecolor);
			
			}else{
				
				var verify:VerifyCredentials = new VerifyCredentials(this, lg, MD5.encrypt(psw), "registered");
			
				var dp:CustomDispatcher = new CustomDispatcher(verify, "checkData");
				dp.doDispatch();
				
			}
			
		}
		
		/**
		* Set the text used in the panel
		* @param title String
		* @param logLabel String
		* @param passLabel String
		*/ 
		private function setText(title:String, logLabel:String, passLabel:String):void{
			
			this.title = title;
			loginLabel.text = logLabel;
			passwordLabel.text = passLabel;
			
		}
		
	}
}